package com.george.relaiscontrol;

import android.app.ProgressDialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.CompoundButton;
import android.widget.ImageButton;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import java.io.IOException;
import java.util.UUID;

public class MainActivity extends AppCompatActivity {
    private ImageButton btnReset, btnPanic, btnDisconnect;
    private Switch Relais1, Relais2, Relais3, Relais4, Relais5, Relais6, Relais7, Relais8, RelaisP, RelaisT;
    private TextView Titel, Status;
    private String Address = null;
    private ProgressDialog Progress;
    private BluetoothAdapter myBluetooth = null;
    private BluetoothSocket btSocket = null;
    private boolean isBtConnected = false;
    //SPP UUID. Look for it
    private static final UUID myUUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        SharedPreferences sharedPrefs = PreferenceManager.getDefaultSharedPreferences(this);

        Intent newint = getIntent();
        Address = newint.getStringExtra(DevicesActivity.EXTRA_ADDRESS); //receive the address of the bluetooth_image device

        //view of the Relais_ControlMain
        setContentView(R.layout.activity_main);
        Titel = findViewById(R.id.mainTitel);
        Titel.setText(sharedPrefs.getString("inst_name", "Geen installatie gekozen"));

        //call the widgets
        Relais1 = findViewById(R.id.relais1);
        Relais2 = findViewById(R.id.relais2);
        Relais3 = findViewById(R.id.relais3);
        Relais4 = findViewById(R.id.relais4);
        Relais5 = findViewById(R.id.relais5);
        Relais6 = findViewById(R.id.relais6);
        Relais7 = findViewById(R.id.relais7);
        Relais8 = findViewById(R.id.relais8);
        RelaisP = findViewById(R.id.relaisP);
        RelaisT = findViewById(R.id.relaisT);
        btnReset = findViewById(R.id.buttonReset);
        btnPanic = findViewById(R.id.buttonPanic);
        btnDisconnect = findViewById(R.id.buttonDisconnect);
        Status = findViewById(R.id.textStatus);

        new ConnectBT().execute(); //Call the class to connect

        //commands to be sent to bluetooth_image
        Relais1.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais1.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("1", isChecked, " ");
            }
        });
        Relais2.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais2.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("2", isChecked, " ");
            }
        });
        Relais3.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais3.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("3", isChecked, " ");
            }
        });
        Relais4.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais4.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("4", isChecked, " ");
            }
        });
        Relais5.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais5.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("5", isChecked, " ");
            }
        });
        Relais6.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais6.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("6", isChecked, " ");
            }
        });
        Relais7.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais7.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("7", isChecked, " ");
            }
        });
        Relais8.setChecked(sharedPrefs.getBoolean("set_relais", false));
        Relais8.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                turnRelais_Control("8", isChecked, " ");
            }
        });

        RelaisP.setChecked(sharedPrefs.getBoolean("set_program", false));
        RelaisP.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    RelaisT.setChecked(false);
                    turnRelais_Control("P", true, "Status: Programma gestart");
                } else {
                    turnRelais_Control("P", false, "Status: Programma gestopt");
                }
            }
        });
        RelaisT.setChecked(sharedPrefs.getBoolean("set_testrun", false));
        RelaisT.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (isChecked) {
                    RelaisP.setChecked(false);
                    turnRelais_Control("T", true, "Status: Testrun gestart");
                } else {
                    turnRelais_Control("T", false, "Status: Testrun gestopt");
                }
            }
        });

        btnReset.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                turnRelais_Control("R", true, "Status: Reset ingedrukt");
            }
        });

        btnPanic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                turnRelais_Control("B", true, "Status: Noodstop gemaakt");
            }
        });

        btnDisconnect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Disconnect(); //close connection
            }
        });

    }

    private void Disconnect() {
        if (btSocket != null) { //If the btSocket is busy
            try {
                btSocket.close(); //close connection
            } catch (IOException e) {
                msg("Error");
            }
        }
        finish(); //return to the first layout
    }

    private void turnRelais_Control(String Object, boolean OnOff, String Remark) {
        if (btSocket!=null) {
            String Command = Object;
                Command += ((OnOff) ? "1" : "0");
            try {
                btSocket.getOutputStream().write(Command.toString().getBytes());
            }
            catch (IOException e) {
                msg("Error");
            }
            if (Character.isDigit(Object.charAt(0)))
                Remark = "Status: Relais " + Object + ((OnOff) ? " aangezet" : " uitgezet");
            Status.setText(Remark);
        }
    }

    // fast way to call Toast
    private void msg(String s) {
        Toast.makeText(getApplicationContext(), s, Toast.LENGTH_LONG).show();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        // Menu in Main uitgeschakeld door geen opties te tonen
        // getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    private class ConnectBT extends AsyncTask<Void, Void, Void> { // UI thread
        private boolean ConnectSuccess = true; //if it's here, it's almost connected

        @Override
        protected void onPreExecute() {
            Progress = ProgressDialog.show(MainActivity.this, "Connecting...", "Please wait!!!");  //show a progress dialog
        }

        @Override
        protected Void doInBackground(Void... devices) { //while the progress dialog is shown, the connection is done in background
            try {
                if (btSocket == null || !isBtConnected) {
                    myBluetooth = BluetoothAdapter.getDefaultAdapter();//get the mobile bluetooth_image device
                    BluetoothDevice dispositivo = myBluetooth.getRemoteDevice(Address);//connects to the device's address and checks if it's available
                    btSocket = dispositivo.createInsecureRfcommSocketToServiceRecord(myUUID);//create a RFCOMM (SPP) connection
                    BluetoothAdapter.getDefaultAdapter().cancelDiscovery();
                    btSocket.connect(); //start connection
                }
            } catch (IOException e) {
                ConnectSuccess = false; //if the try failed, you can check the exception here
            }
            return null;
        }

        @Override
        protected void onPostExecute(Void result) { //after the doInBackground, it checks if everything went fine
            super.onPostExecute(result);
            if (!ConnectSuccess){
            msg("Connection Failed. Is it a SPP Bluetooth? Try again.");
                finish();
            } else {
            msg("Connected.");
            isBtConnected = true;
            }
            Progress.dismiss();
        }
    }
}
